// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/PreEurLex.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class PreEurLex extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inNota = 2;
  public static final int inClean = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\u10df\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\3\1\4\22\0\1\3"+
    "\1\0\1\5\3\0\1\6\1\0\1\7\1\10\1\11"+
    "\2\0\1\12\1\13\1\0\12\14\1\0\1\15\1\16"+
    "\4\0\1\17\1\20\1\21\1\22\1\23\3\0\1\24"+
    "\2\0\1\25\1\26\1\27\1\30\1\31\1\32\1\33"+
    "\1\34\1\35\1\36\1\37\1\0\1\40\6\0\1\12"+
    "\1\0\1\41\1\42\1\43\1\44\1\45\3\46\1\47"+
    "\2\46\1\50\1\51\1\52\1\53\1\54\1\55\1\56"+
    "\1\57\1\60\1\61\1\62\1\46\1\63\2\46\60\0"+
    "\1\64\17\0\1\65\164\0\2\24\115\0\1\34\u0182\0"+
    "\1\3\20\0\2\12\7\0\1\64\343\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1024];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\13\0\6\1\1\2\2\3\2\2\2\4\24\0\1\5"+
    "\12\0\2\6\1\0\2\7\3\0\2\4\30\0\2\10"+
    "\24\0\2\11\2\12\2\13\12\0\2\14\4\0\1\4"+
    "\16\0\1\15\3\0\2\16\15\0\2\17\23\0\3\10"+
    "\54\0\3\12\3\13\17\0\3\14\155\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[368];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\66\0\154\0\242\0\330\0\u010e\0\u0144\0\u017a"+
    "\0\u01b0\0\u01e6\0\u021c\0\u0252\0\u0288\0\u02be\0\u02f4\0\u032a"+
    "\0\u0360\0\u0252\0\u0252\0\u0396\0\u03cc\0\u0402\0\u0438\0\u046e"+
    "\0\u04a4\0\u04da\0\u0510\0\u0546\0\u057c\0\u05b2\0\u05e8\0\u061e"+
    "\0\u0654\0\u068a\0\u06c0\0\u06f6\0\u072c\0\u0762\0\u0798\0\u0288"+
    "\0\u07ce\0\u0804\0\u032a\0\u0360\0\u07ce\0\u083a\0\u0870\0\u08a6"+
    "\0\u08dc\0\u0912\0\u0948\0\u097e\0\u02be\0\u09b4\0\u09ea\0\u0252"+
    "\0\u0a20\0\u0a56\0\u0252\0\u0a8c\0\u0ac2\0\u0af8\0\u0b2e\0\u0252"+
    "\0\u0b64\0\u0b9a\0\u0bd0\0\u0c06\0\u0c3c\0\u0c72\0\u0ca8\0\u0cde"+
    "\0\u0d14\0\u05b2\0\u0252\0\u0d4a\0\u0d80\0\u0db6\0\u0dec\0\u0e22"+
    "\0\u0e58\0\u0e8e\0\u0252\0\u0ec4\0\u0efa\0\u0f30\0\u0f66\0\u0f9c"+
    "\0\u0fd2\0\u1008\0\u103e\0\u1074\0\u10aa\0\u10e0\0\u1116\0\u114c"+
    "\0\u1182\0\u11b8\0\u11ee\0\u1224\0\u125a\0\u1290\0\u12c6\0\u12fc"+
    "\0\u1332\0\u1368\0\u139e\0\u13d4\0\u140a\0\u1440\0\u1476\0\u0252"+
    "\0\u14ac\0\u14e2\0\u1518\0\u154e\0\u1584\0\u15ba\0\u15f0\0\u1626"+
    "\0\u165c\0\u1692\0\u16c8\0\u16fe\0\u1734\0\u176a\0\u17a0\0\u17d6"+
    "\0\u180c\0\u1842\0\u1878\0\u18ae\0\u18e4\0\u1290\0\u191a\0\u1950"+
    "\0\u1986\0\u19bc\0\u19f2\0\u1a28\0\u1a5e\0\u1a94\0\u1aca\0\u1b00"+
    "\0\u1b36\0\u1b6c\0\u1ba2\0\u1bd8\0\u0252\0\u1c0e\0\u1c44\0\u1c7a"+
    "\0\u0252\0\u1cb0\0\u1ce6\0\u1d1c\0\u1d52\0\u1d88\0\u1dbe\0\u1df4"+
    "\0\u1e2a\0\u1e60\0\u1e96\0\u1ecc\0\u1f02\0\u1f38\0\u1f6e\0\u0252"+
    "\0\u1fa4\0\u1fda\0\u2010\0\u2046\0\u207c\0\u20b2\0\u20e8\0\u211e"+
    "\0\u2154\0\u218a\0\u21c0\0\u21f6\0\u222c\0\u2262\0\u2298\0\u22ce"+
    "\0\u2304\0\u233a\0\u2370\0\u23a6\0\u0252\0\u23dc\0\u1c0e\0\u2412"+
    "\0\u2448\0\u247e\0\u24b4\0\u24ea\0\u2520\0\u2556\0\u258c\0\u25c2"+
    "\0\u25f8\0\u262e\0\u2664\0\u269a\0\u26d0\0\u2706\0\u273c\0\u2772"+
    "\0\u27a8\0\u27de\0\u2814\0\u284a\0\u2880\0\u28b6\0\u28ec\0\u2922"+
    "\0\u2958\0\u298e\0\u29c4\0\u29fa\0\u2a30\0\u2a66\0\u2a9c\0\u2ad2"+
    "\0\u2b08\0\u2b3e\0\u2b74\0\u2baa\0\u2be0\0\u2c16\0\u2c4c\0\u2c82"+
    "\0\u2cb8\0\u2cee\0\u2d24\0\u0252\0\u2d5a\0\u2412\0\u0252\0\u2d90"+
    "\0\u247e\0\u2dc6\0\u2dfc\0\u2e32\0\u2e68\0\u2e9e\0\u2ed4\0\u2f0a"+
    "\0\u2f40\0\u2f76\0\u2fac\0\u2fe2\0\u3018\0\u304e\0\u3084\0\u30ba"+
    "\0\u0252\0\u30f0\0\u284a\0\u3126\0\u315c\0\u3192\0\u31c8\0\u31fe"+
    "\0\u3234\0\u326a\0\u32a0\0\u32d6\0\u330c\0\u3342\0\u3378\0\u33ae"+
    "\0\u33e4\0\u341a\0\u3450\0\u3486\0\u34bc\0\u34f2\0\u3528\0\u355e"+
    "\0\u3594\0\u35ca\0\u3600\0\u3636\0\u366c\0\u36a2\0\u36d8\0\u370e"+
    "\0\u3744\0\u377a\0\u37b0\0\u37e6\0\u381c\0\u3852\0\u3888\0\u38be"+
    "\0\u38f4\0\u392a\0\u3960\0\u3996\0\u39cc\0\u3a02\0\u3a38\0\u3a6e"+
    "\0\u3aa4\0\u3ada\0\u3b10\0\u3b46\0\u3b7c\0\u3bb2\0\u3be8\0\u3c1e"+
    "\0\u3c54\0\u3c8a\0\u3cc0\0\u3cf6\0\u3d2c\0\u3d62\0\u3d98\0\u3dce"+
    "\0\u3e04\0\u3e3a\0\u3e70\0\u3ea6\0\u3edc\0\u3f12\0\u3f48\0\u3f7e"+
    "\0\u3fb4\0\u3fea\0\u4020\0\u4056\0\u408c\0\u40c2\0\u40f8\0\u412e"+
    "\0\u4164\0\u419a\0\u41d0\0\u4206\0\u423c\0\u4272\0\u42a8\0\u42de"+
    "\0\u4314\0\u434a\0\u4380\0\u43b6\0\u43ec\0\u4422\0\u4458\0\u448e"+
    "\0\u44c4\0\u44fa\0\u4530\0\u4566\0\u459c\0\u45d2\0\u4608\0\u463e"+
    "\0\u4674\0\u46aa\0\u46e0\0\u4716\0\u474c\0\u4782\0\u47b8\0\u47ee";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[368];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\14\1\15\1\16\1\15\1\17\1\14\1\20\1\21"+
    "\56\14\2\22\1\23\1\22\1\24\1\25\57\22\1\26"+
    "\2\23\1\27\1\23\1\30\61\23\2\0\1\31\1\0"+
    "\1\32\63\0\1\33\1\0\1\34\63\0\1\35\1\0"+
    "\1\36\63\0\1\37\1\0\1\40\63\0\1\41\1\0"+
    "\1\42\63\0\1\43\1\0\1\44\146\0\1\45\2\0"+
    "\1\46\1\0\1\47\150\0\1\50\1\51\1\50\1\52"+
    "\1\0\1\53\1\54\57\0\1\55\1\0\1\51\1\0"+
    "\1\56\1\57\1\60\2\0\1\61\1\0\1\62\1\0"+
    "\1\63\22\0\23\64\1\56\2\0\1\55\1\65\1\51"+
    "\1\0\1\56\1\57\1\60\2\0\1\61\1\0\1\62"+
    "\1\0\1\63\22\0\23\64\1\56\30\0\1\66\22\0"+
    "\1\66\24\0\1\67\56\0\1\23\65\0\1\70\1\0"+
    "\1\71\62\0\1\72\1\73\1\72\1\74\1\72\1\75"+
    "\4\0\1\76\1\0\1\76\51\0\1\77\1\100\1\0"+
    "\1\101\62\0\1\77\1\27\1\0\1\101\66\0\1\102"+
    "\1\0\1\103\4\0\1\104\1\0\1\105\45\0\1\102"+
    "\3\0\1\31\2\0\1\102\1\0\1\103\4\0\1\104"+
    "\1\0\1\105\45\0\1\102\3\0\1\106\1\0\1\107"+
    "\63\0\1\106\1\0\1\110\63\0\1\111\1\0\1\112"+
    "\63\0\1\111\1\0\1\113\66\0\1\114\1\0\1\115"+
    "\6\0\1\116\22\0\23\117\1\114\3\0\1\37\2\0"+
    "\1\114\1\0\1\115\6\0\1\116\22\0\23\117\1\114"+
    "\6\0\1\120\6\0\1\121\1\0\1\122\45\0\1\120"+
    "\3\0\1\41\2\0\1\120\6\0\1\121\1\0\1\122"+
    "\45\0\1\120\13\0\1\123\55\0\1\43\7\0\1\123"+
    "\66\0\1\123\1\0\1\123\51\0\1\47\1\0\2\47"+
    "\1\113\7\0\1\124\51\0\1\47\1\0\1\47\1\0"+
    "\1\113\7\0\1\124\51\0\1\51\1\0\1\51\2\0"+
    "\1\57\1\125\57\0\3\51\2\0\1\57\1\125\65\0"+
    "\1\126\4\0\1\62\24\0\23\64\31\0\1\127\22\0"+
    "\1\127\24\0\1\130\2\0\1\131\24\0\23\64\4\0"+
    "\1\132\1\0\1\133\71\0\1\134\2\0\1\135\1\62"+
    "\67\0\1\56\50\0\1\136\1\0\1\136\2\0\1\137"+
    "\1\0\1\140\1\0\1\141\26\0\23\64\22\0\1\142"+
    "\21\0\1\142\24\0\1\67\1\0\1\67\2\0\1\143"+
    "\5\0\1\144\53\0\1\70\64\0\1\72\1\73\1\72"+
    "\1\74\1\0\1\75\61\0\1\73\112\0\1\145\22\0"+
    "\1\145\14\0\1\72\1\73\1\72\1\74\1\72\1\75"+
    "\61\0\1\146\1\0\1\147\63\0\1\100\72\0\1\103"+
    "\4\0\1\104\65\0\1\104\61\0\1\123\3\0\1\104"+
    "\67\0\1\102\50\0\1\36\2\0\1\110\62\0\1\36"+
    "\1\106\1\0\1\110\62\0\1\36\70\0\1\113\70\0"+
    "\1\115\31\0\23\117\43\0\23\117\20\0\1\114\50\0"+
    "\1\150\1\0\1\150\2\0\1\151\1\0\1\123\1\0"+
    "\1\152\26\0\23\117\16\0\1\121\64\0\1\123\1\121"+
    "\67\0\1\120\100\0\1\153\22\0\1\153\22\0\1\130"+
    "\70\0\1\131\24\0\23\64\22\0\1\154\21\0\1\154"+
    "\24\0\1\130\1\0\1\130\2\0\1\155\5\0\1\156"+
    "\61\0\1\134\3\0\1\131\52\0\1\157\1\160\1\0"+
    "\1\161\62\0\1\157\1\132\1\0\1\161\63\0\1\162"+
    "\1\0\1\163\63\0\1\164\1\0\1\165\62\0\1\136"+
    "\1\0\1\136\2\0\1\137\3\0\1\141\5\0\1\166"+
    "\1\0\1\167\4\0\1\170\1\171\1\0\1\172\1\0"+
    "\1\173\1\174\1\175\1\176\2\0\1\166\1\0\1\167"+
    "\5\0\1\170\1\171\1\0\1\172\1\0\1\173\1\174"+
    "\1\175\1\176\32\0\1\177\22\0\1\177\15\0\1\200"+
    "\1\0\1\201\62\0\1\141\1\0\1\141\2\0\1\202"+
    "\11\0\1\166\1\0\1\167\4\0\1\170\1\171\1\0"+
    "\1\172\1\0\1\173\1\174\1\175\1\176\2\0\1\166"+
    "\1\0\1\167\5\0\1\170\1\171\1\0\1\172\1\0"+
    "\1\173\1\174\1\175\1\176\37\0\1\203\22\0\1\203"+
    "\35\0\1\204\22\0\1\204\23\0\1\22\3\0\1\144"+
    "\71\0\1\205\21\0\1\205\25\0\1\100\1\0\1\101"+
    "\63\0\1\206\1\0\1\101\62\0\1\150\1\0\1\150"+
    "\2\0\1\151\3\0\1\152\5\0\1\207\1\0\1\210"+
    "\4\0\1\211\1\212\1\0\1\213\1\0\1\214\1\215"+
    "\1\216\1\217\2\0\1\207\1\0\1\210\5\0\1\211"+
    "\1\212\1\0\1\213\1\0\1\214\1\215\1\216\1\217"+
    "\32\0\1\220\22\0\1\220\14\0\1\152\1\0\1\152"+
    "\2\0\1\221\11\0\1\207\1\0\1\210\4\0\1\211"+
    "\1\212\1\0\1\213\1\0\1\214\1\215\1\216\1\217"+
    "\2\0\1\207\1\0\1\210\5\0\1\211\1\212\1\0"+
    "\1\213\1\0\1\214\1\215\1\216\1\217\37\0\1\222"+
    "\22\0\1\222\42\0\1\223\22\0\1\223\35\0\1\224"+
    "\22\0\1\224\23\0\1\225\3\0\1\156\53\0\1\226"+
    "\1\0\1\227\63\0\1\160\64\0\1\230\1\231\1\0"+
    "\1\232\62\0\1\230\1\162\1\0\1\232\62\0\1\233"+
    "\65\0\1\233\1\164\107\0\1\234\22\0\1\234\41\0"+
    "\1\235\12\0\1\236\6\0\1\235\13\0\1\236\34\0"+
    "\1\237\22\0\1\237\33\0\1\240\21\0\1\240\60\0"+
    "\1\241\22\0\1\241\27\0\1\242\21\0\1\242\43\0"+
    "\1\243\21\0\1\243\47\0\1\244\22\0\1\244\37\0"+
    "\1\245\22\0\1\245\36\0\1\246\21\0\1\246\24\0"+
    "\1\247\1\250\1\0\1\251\62\0\1\247\1\200\1\0"+
    "\1\251\110\0\1\252\22\0\1\252\44\0\1\253\22\0"+
    "\1\253\31\0\1\254\21\0\1\254\57\0\1\255\22\0"+
    "\1\255\32\0\1\256\22\0\1\256\41\0\1\257\12\0"+
    "\1\260\6\0\1\257\13\0\1\260\34\0\1\261\22\0"+
    "\1\261\33\0\1\262\21\0\1\262\60\0\1\263\22\0"+
    "\1\263\27\0\1\264\21\0\1\264\43\0\1\265\21\0"+
    "\1\265\47\0\1\266\22\0\1\266\37\0\1\267\22\0"+
    "\1\267\36\0\1\270\21\0\1\270\52\0\1\271\22\0"+
    "\1\271\33\0\1\272\21\0\1\272\54\0\1\273\22\0"+
    "\1\273\31\0\1\274\21\0\1\274\25\0\1\275\1\0"+
    "\1\276\63\0\1\277\1\0\1\276\63\0\1\300\1\0"+
    "\1\301\63\0\1\231\65\0\1\302\1\0\1\303\115\0"+
    "\1\304\22\0\1\304\27\0\1\305\21\0\1\305\52\0"+
    "\1\244\22\0\1\244\41\0\1\306\7\0\1\307\12\0"+
    "\1\306\7\0\1\307\40\0\1\307\22\0\1\307\24\0"+
    "\1\310\4\0\1\311\14\0\1\310\5\0\1\311\40\0"+
    "\1\312\1\0\1\313\1\0\1\314\2\0\1\315\6\0"+
    "\1\316\3\0\1\312\2\0\1\313\1\0\1\314\2\0"+
    "\1\315\6\0\1\316\35\0\1\317\22\0\1\317\31\0"+
    "\1\320\14\0\1\321\4\0\1\320\15\0\1\321\24\0"+
    "\1\322\21\0\1\322\56\0\1\323\22\0\1\323\10\0"+
    "\1\324\1\0\1\325\63\0\1\250\103\0\1\326\21\0"+
    "\1\326\40\0\1\50\104\0\1\327\22\0\1\327\37\0"+
    "\1\330\22\0\1\330\45\0\1\331\22\0\1\331\27\0"+
    "\1\332\21\0\1\332\52\0\1\266\22\0\1\266\41\0"+
    "\1\333\7\0\1\334\12\0\1\333\7\0\1\334\40\0"+
    "\1\334\22\0\1\334\24\0\1\335\4\0\1\336\14\0"+
    "\1\335\5\0\1\336\40\0\1\337\1\0\1\340\1\0"+
    "\1\341\2\0\1\342\6\0\1\343\3\0\1\337\2\0"+
    "\1\340\1\0\1\341\2\0\1\342\6\0\1\343\35\0"+
    "\1\344\22\0\1\344\31\0\1\345\14\0\1\346\4\0"+
    "\1\345\15\0\1\346\24\0\1\347\21\0\1\347\56\0"+
    "\1\350\22\0\1\350\26\0\1\351\21\0\1\351\52\0"+
    "\1\352\22\0\1\352\30\0\1\51\104\0\1\353\22\0"+
    "\1\353\10\0\1\275\65\0\1\354\1\0\1\355\63\0"+
    "\1\356\1\0\1\355\63\0\1\357\1\0\1\360\63\0"+
    "\1\361\1\0\1\360\62\0\1\362\1\0\1\362\2\0"+
    "\1\363\1\0\1\140\26\0\1\321\22\0\1\321\27\0"+
    "\1\364\22\0\1\364\42\0\1\365\22\0\1\365\42\0"+
    "\1\366\3\0\1\367\16\0\1\366\3\0\1\367\45\0"+
    "\1\370\1\0\1\174\20\0\1\370\1\0\1\174\34\0"+
    "\1\371\22\0\1\371\36\0\1\235\21\0\1\235\43\0"+
    "\1\372\21\0\1\372\43\0\1\373\21\0\1\373\55\0"+
    "\1\316\22\0\1\316\27\0\1\312\1\0\1\366\17\0"+
    "\1\312\2\0\1\366\17\0\1\374\1\0\1\374\2\0"+
    "\1\375\1\0\1\140\11\0\1\312\14\0\1\321\4\0"+
    "\1\312\15\0\1\321\26\0\1\376\21\0\1\376\44\0"+
    "\1\235\22\0\1\235\42\0\1\377\22\0\1\377\47\0"+
    "\1\u0100\22\0\1\u0100\13\0\1\u0101\1\0\1\u0102\63\0"+
    "\1\u0103\1\0\1\u0102\115\0\1\u0104\22\0\1\u0104\37\0"+
    "\1\u0105\22\0\1\u0105\26\0\1\72\51\0\1\u0106\1\0"+
    "\1\u0106\2\0\1\u0107\1\0\1\123\26\0\1\346\22\0"+
    "\1\346\27\0\1\u0108\22\0\1\u0108\42\0\1\u0109\22\0"+
    "\1\u0109\42\0\1\u010a\3\0\1\u010b\16\0\1\u010a\3\0"+
    "\1\u010b\45\0\1\u010c\1\0\1\215\20\0\1\u010c\1\0"+
    "\1\215\34\0\1\u010d\22\0\1\u010d\36\0\1\257\21\0"+
    "\1\257\43\0\1\u010e\21\0\1\u010e\43\0\1\u010f\21\0"+
    "\1\u010f\55\0\1\343\22\0\1\343\27\0\1\337\1\0"+
    "\1\u010a\17\0\1\337\2\0\1\u010a\17\0\1\u0110\1\0"+
    "\1\u0110\2\0\1\u0111\1\0\1\123\11\0\1\337\14\0"+
    "\1\346\4\0\1\337\15\0\1\346\26\0\1\u0112\21\0"+
    "\1\u0112\44\0\1\257\22\0\1\257\42\0\1\u0113\22\0"+
    "\1\u0113\47\0\1\u0114\22\0\1\u0114\45\0\1\u0115\22\0"+
    "\1\u0115\14\0\1\47\110\0\1\u0116\22\0\1\u0116\13\0"+
    "\1\354\65\0\1\357\64\0\1\362\1\0\1\362\2\0"+
    "\1\363\30\0\1\321\22\0\1\321\32\0\1\u0117\22\0"+
    "\1\u0117\36\0\1\u0118\21\0\1\u0118\43\0\1\u0119\21\0"+
    "\1\u0119\43\0\1\u011a\21\0\1\u011a\42\0\1\312\21\0"+
    "\1\312\56\0\1\u011b\22\0\1\u011b\27\0\1\312\7\0"+
    "\1\u011c\4\0\1\321\4\0\1\312\10\0\1\u011c\4\0"+
    "\1\321\37\0\1\u011d\22\0\1\u011d\33\0\1\304\22\0"+
    "\1\304\16\0\1\374\1\0\1\374\2\0\1\375\13\0"+
    "\1\312\14\0\1\321\4\0\1\312\15\0\1\321\32\0"+
    "\1\u011e\22\0\1\u011e\34\0\1\305\15\0\1\321\3\0"+
    "\1\305\16\0\1\321\26\0\1\u011f\21\0\1\u011f\35\0"+
    "\1\136\52\0\1\u0101\114\0\1\u0120\22\0\1\u0120\26\0"+
    "\1\67\51\0\1\u0106\1\0\1\u0106\2\0\1\u0107\30\0"+
    "\1\346\22\0\1\346\32\0\1\u0121\22\0\1\u0121\36\0"+
    "\1\u0122\21\0\1\u0122\43\0\1\u0123\21\0\1\u0123\43\0"+
    "\1\u0124\21\0\1\u0124\42\0\1\337\21\0\1\337\56\0"+
    "\1\u0125\22\0\1\u0125\27\0\1\337\7\0\1\u0126\4\0"+
    "\1\346\4\0\1\337\10\0\1\u0126\4\0\1\346\37\0"+
    "\1\u0127\22\0\1\u0127\33\0\1\331\22\0\1\331\16\0"+
    "\1\u0110\1\0\1\u0110\2\0\1\u0111\13\0\1\337\14\0"+
    "\1\346\4\0\1\337\15\0\1\346\32\0\1\u0128\22\0"+
    "\1\u0128\34\0\1\332\15\0\1\346\3\0\1\332\16\0"+
    "\1\346\26\0\1\u0129\21\0\1\u0129\35\0\1\150\101\0"+
    "\1\u012a\22\0\1\u012a\26\0\1\130\70\0\1\u012b\21\0"+
    "\1\u012b\52\0\1\u0119\4\0\1\u012c\15\0\1\u0119\4\0"+
    "\1\u012c\42\0\1\u012c\22\0\1\u012c\35\0\1\u0119\4\0"+
    "\1\u012d\15\0\1\u0119\4\0\1\u012d\31\0\1\u012e\21\0"+
    "\1\u012e\56\0\1\u012f\22\0\1\u012f\5\0\1\u011d\1\0"+
    "\1\u011d\2\0\1\u0130\13\0\1\312\21\0\1\312\41\0"+
    "\1\u0131\21\0\1\u0131\52\0\1\u0132\4\0\1\u0133\15\0"+
    "\1\u0132\4\0\1\u0133\23\0\1\141\70\0\1\u0134\21\0"+
    "\1\u0134\52\0\1\u0123\4\0\1\u0135\15\0\1\u0123\4\0"+
    "\1\u0135\42\0\1\u0135\22\0\1\u0135\35\0\1\u0123\4\0"+
    "\1\u0136\15\0\1\u0123\4\0\1\u0136\31\0\1\u0137\21\0"+
    "\1\u0137\56\0\1\u0138\22\0\1\u0138\5\0\1\u0127\1\0"+
    "\1\u0127\2\0\1\u0139\13\0\1\337\21\0\1\337\41\0"+
    "\1\u013a\21\0\1\u013a\52\0\1\u013b\4\0\1\u013c\15\0"+
    "\1\u013b\4\0\1\u013c\23\0\1\152\104\0\1\u013d\22\0"+
    "\1\u013d\16\0\1\140\56\0\1\u011d\1\0\1\u011d\2\0"+
    "\1\u0130\1\0\1\140\11\0\1\312\21\0\1\312\54\0"+
    "\1\u012c\22\0\1\u012c\33\0\1\u013e\22\0\1\u013e\45\0"+
    "\1\u013f\22\0\1\u013f\47\0\1\u0140\22\0\1\u0140\42\0"+
    "\1\u0133\22\0\1\u0133\7\0\1\u0141\1\0\1\u0141\2\0"+
    "\1\u0142\1\0\1\140\7\0\1\u0143\11\0\1\u0144\1\0"+
    "\1\u0145\1\u011b\4\0\1\u0143\12\0\1\u0144\1\0\1\u0145"+
    "\1\u011b\41\0\1\u0146\22\0\1\u0146\16\0\1\123\56\0"+
    "\1\u0127\1\0\1\u0127\2\0\1\u0139\1\0\1\123\11\0"+
    "\1\337\21\0\1\337\54\0\1\u0135\22\0\1\u0135\33\0"+
    "\1\u0147\22\0\1\u0147\45\0\1\u0148\22\0\1\u0148\47\0"+
    "\1\u0149\22\0\1\u0149\42\0\1\u013c\22\0\1\u013c\7\0"+
    "\1\u014a\1\0\1\u014a\2\0\1\u014b\1\0\1\123\7\0"+
    "\1\u014c\11\0\1\u014d\1\0\1\u014e\1\u0125\4\0\1\u014c"+
    "\12\0\1\u014d\1\0\1\u014e\1\u0125\36\0\1\u014f\22\0"+
    "\1\u014f\34\0\1\u0150\21\0\1\u0150\40\0\1\u0151\21\0"+
    "\1\u0151\54\0\1\u0152\22\0\1\u0152\12\0\1\u0141\1\0"+
    "\1\u0141\2\0\1\u0142\11\0\1\u0143\11\0\1\u0144\1\0"+
    "\1\u0145\1\u011b\4\0\1\u0143\12\0\1\u0144\1\0\1\u0145"+
    "\1\u011b\34\0\1\u0153\22\0\1\u0153\37\0\1\u0119\22\0"+
    "\1\u0119\54\0\1\u0154\22\0\1\u0154\27\0\1\u0155\21\0"+
    "\1\u0155\51\0\1\u0156\22\0\1\u0156\34\0\1\u0157\21\0"+
    "\1\u0157\40\0\1\u0158\21\0\1\u0158\54\0\1\u0159\22\0"+
    "\1\u0159\12\0\1\u014a\1\0\1\u014a\2\0\1\u014b\11\0"+
    "\1\u014c\11\0\1\u014d\1\0\1\u014e\1\u0125\4\0\1\u014c"+
    "\12\0\1\u014d\1\0\1\u014e\1\u0125\34\0\1\u015a\22\0"+
    "\1\u015a\37\0\1\u0123\22\0\1\u0123\54\0\1\u015b\22\0"+
    "\1\u015b\27\0\1\u015c\21\0\1\u015c\35\0\1\362\77\0"+
    "\1\234\4\0\1\317\15\0\1\234\4\0\1\317\42\0"+
    "\1\u015d\22\0\1\u015d\23\0\1\374\70\0\1\u015e\21\0"+
    "\1\u015e\42\0\1\370\4\0\1\u015f\14\0\1\370\5\0"+
    "\1\u015f\44\0\1\u0160\22\0\1\u0160\31\0\1\u0106\77\0"+
    "\1\256\4\0\1\344\15\0\1\256\4\0\1\344\42\0"+
    "\1\u0161\22\0\1\u0161\23\0\1\u0110\70\0\1\u0162\21\0"+
    "\1\u0162\42\0\1\u010c\4\0\1\u0163\14\0\1\u010c\5\0"+
    "\1\u0163\44\0\1\u0164\22\0\1\u0164\45\0\1\u0165\22\0"+
    "\1\u0165\45\0\1\u0166\22\0\1\u0166\35\0\1\u0167\22\0"+
    "\1\u0167\36\0\1\u0168\21\0\1\u0168\51\0\1\u0169\22\0"+
    "\1\u0169\45\0\1\u016a\22\0\1\u016a\35\0\1\u016b\22\0"+
    "\1\u016b\36\0\1\u016c\21\0\1\u016c\35\0\1\u011d\101\0"+
    "\1\u016d\22\0\1\u016d\43\0\1\u016e\22\0\1\u016e\35\0"+
    "\1\u012c\22\0\1\u012c\32\0\1\u0127\101\0\1\u016f\22\0"+
    "\1\u016f\43\0\1\u0170\22\0\1\u0170\35\0\1\u0135\22\0"+
    "\1\u0135\32\0\1\u0141\106\0\1\305\22\0\1\305\21\0"+
    "\1\u014a\106\0\1\332\22\0\1\332\4\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[18468];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\13\0\1\11\5\1\2\11\5\1\2\0\2\1\10\0"+
    "\3\1\5\0\1\1\12\0\1\11\1\1\1\0\1\11"+
    "\1\1\3\0\1\11\1\1\5\0\1\1\1\0\2\1"+
    "\1\11\7\0\1\11\6\0\2\1\24\0\1\11\5\1"+
    "\12\0\2\1\4\0\1\1\16\0\1\11\3\0\1\11"+
    "\1\1\15\0\1\11\1\1\23\0\1\11\2\1\54\0"+
    "\1\11\2\1\1\11\2\1\17\0\1\11\2\1\155\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[368];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	PreEurLex() { }
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PreEurLex(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 16: break;
          case 2:
            { 
            }
          // fall through
          case 17: break;
          case 3:
            { output.append(yytext()); yybegin(0);
            }
          // fall through
          case 18: break;
          case 4:
            { output.append(" "); yybegin(0);
            }
          // fall through
          case 19: break;
          case 5:
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzMarkedPos, -1);
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 20: break;
          case 6:
            // lookahead expression with fixed base length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL, zzStartRead, zzEndRead - zzStartRead, zzStartRead, 1);
            { yybegin(0);
            }
          // fall through
          case 21: break;
          case 7:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 9;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 10;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext());
            }
          // fall through
          case 22: break;
          case 8:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 8;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 4;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 23: break;
          case 9:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 8;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 5;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 24: break;
          case 10:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 3;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 4;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 25: break;
          case 11:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 7;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 4;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 26: break;
          case 12:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 6;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 4;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 27: break;
          case 13:
            { yybegin(inNota);
            }
          // fall through
          case 28: break;
          case 14:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 3;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 5;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 29: break;
          case 15:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 6;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 5;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append(yytext()); yybegin(inClean);
            }
          // fall through
          case 30: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java PreEurLex [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        PreEurLex scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new PreEurLex(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
